﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Activation;
using System.ServiceModel.Web;
using System.Text;

namespace WebApp
{
    [DataContract]
    public class Person
    {
        [DataMember(Name = "Name")]
        public string Name { set; get; }
        [DataMember(Name = "Age")]
        public int Age { set; get; }
        [DataMember(Name = "Sex")]
        public string Sex { set; get; }
    }

    [DataContract]
    public class Query<T>
    {
        [DataMember(Name = "SearchResult")]
        public IList<T> SearchResult { set; get; }
        [DataMember(Name = "RecordCount")]
        public int RecordCount { set; get; }
    }

    [ServiceContract(Namespace = "")]
    [AspNetCompatibilityRequirements(RequirementsMode = AspNetCompatibilityRequirementsMode.Allowed)]
    public class PersonService
    {
        [OperationContract]
        public Query<Person> GetPersonList(int a, int pageIndex, int pageSize)
        {
            if (pageIndex % 2 == 0)
            {
                return new Query<Person>() { RecordCount = 100, SearchResult = new List<Person>() { new Person() { Name = "yangql", Age = 25, Sex = "女" }, new Person() { Name = "zhoulq", Age = 29, Sex = "男" }, new Person() { Name = "zhouqp", Age = 30, Sex = "男" }, new Person() { Name = "pizm", Age = 30, Sex = "男" }, new Person() { Name = "zhangwj", Age = 25, Sex = "女" } } };
            }
            else
            {
                return new Query<Person>() { RecordCount = 100, SearchResult = new List<Person>() {  new Person() { Name = "zhangxr", Age = 29, Sex = "女" }, new Person() { Name = "zuojie", Age = 29, Sex = "女" }, new Person() { Name = "yangfei", Age = 28, Sex = "男" }, new Person() { Name = "yangwei", Age = 30, Sex = "男" }, new Person() { Name = "zhengjj", Age = 28, Sex = "女" } } };
            }
        }
    }
}
