﻿(function ($) {
    $.fn.pager = function (pageSize, onPageChanged, showPageInfo, showNumberArea, numberSize) {
        if ($.isFunction(onPageChanged) && pageSize > 0) {
            var id = this.attr("id");
            var token = "#" + id;
            this.empty().data("pageSize", pageSize).data("pageIndex", 1);
            var changeState = function (pageTotal, pageIndex) {
                $(token + " .page_first," + token + " .page_prev," + token + " .page_last," + token + " .page_next").unbind();
                if (pageIndex == 1) {
                    $(token + " .page_first").removeClass("page_btn_actived").addClass("page_btn");
                    $(token + " .page_prev").removeClass("page_btn_actived").addClass("page_btn");
                }
                else {
                    $(token + " .page_first").bind("click", pageFirst).hover(function () {
                        $(this).removeClass("page_btn").addClass("page_btn_actived");
                    }, function () {
                        $(this).removeClass("page_btn_actived").addClass("page_btn");
                    });;
                    $(token + " .page_prev").bind("click", pagePre).hover(function () {
                        $(this).removeClass("page_btn").addClass("page_btn_actived");
                    }, function () {
                        $(this).removeClass("page_btn_actived").addClass("page_btn");
                    });;
                }
                if (pageIndex == pageTotal) {
                    $(token + " .page_last").removeClass("page_btn_actived").addClass("page_btn");
                    $(token + " .page_next").removeClass("page_btn_actived").addClass("page_btn");
                }
                else {
                    $(token + " .page_last").bind("click", pageLast).hover(function () {
                        $(this).removeClass("page_btn").addClass("page_btn_actived");
                    }, function () {
                        $(this).removeClass("page_btn_actived").addClass("page_btn");
                    });;
                    $(token + " .page_next").bind("click", pageNext).hover(function () {
                        $(this).removeClass("page_btn").addClass("page_btn_actived");
                    }, function () {
                        $(this).removeClass("page_btn_actived").addClass("page_btn");
                    });;
                }
            };
            var initCustomer = function (totalCount, pageTotal, pageSize, pageIndex) {
                $(token + "_customer").html("<span class='customer'>共${totalCount}条&nbsp;每页${pageSize}条&nbsp;第${pageIndex}/${pageTotal}页&nbsp;</span><div class='page_separator'></div>".replace(/\$\{\s*pageTotal\s*\}/gi, pageTotal).replace(/\$\{\s*pageIndex\s*\}/gi, pageIndex).replace(/\$\{\s*totalCount\s*\}/gi, totalCount).replace(/\$\{\s*pageSize\s*\}/gi, pageSize));
            };
            var initNumber = function (pageTotal, numberSize, currentIndex) {
                if (pageTotal > 0 && numberSize > 0) {
                    if (currentIndex < 1) {
                        currentIndex = 1;
                    }
                    if (currentIndex > pageTotal) {
                        currentIndex = pageTotal;
                    }
                    var endIndex = pageTotal;
                    var startIndex = 1;
                    var temp = currentIndex + Math.floor(numberSize / 2);
                    if (temp < pageTotal) {
                        if (temp < numberSize) {
                            endIndex = numberSize;
                        }
                        else {
                            startIndex = temp - numberSize + 1;
                            endIndex = temp;
                        }
                    }
                    else {
                        if (pageTotal > numberSize) {
                            startIndex = pageTotal - numberSize + 1;
                        }
                    }
                    $(token + "_num").empty();
                    for (var i = startIndex; i <= endIndex; i++) {
                        var html = $("<span></span>").text(i).bind("click", pageNumber);
                        if (i == currentIndex) {
                            $(token + "_num").append(html.attr("class", "selected"));
                        }
                        else {
                            $(token + "_num").append(html);
                        }
                    }
                }
            };
            var reflushPager = function (toalCount, pageSize, pageIndex) {
                var pageTotal = Math.ceil(toalCount / pageSize);
                changeState(pageTotal, pageIndex);
                if (showPageInfo) {
                    initCustomer(toalCount, pageTotal, pageSize, pageIndex);
                }
                if (showNumberArea) {
                    initNumber(pageTotal, numberSize, pageIndex);
                }
            }
            var pageChanged = function (index) {
                debugger;
                var e = { "pageSize": $(token).data("pageSize"), "pageIndex": index };
                var totalCount=onPageChanged(e);
                $(token).data("totalCount", totalCount).data("pageIndex", index);
                reflushPager(totalCount, $(token).data("pageSize"), index);
            }
            var pageFirst = function () {
                pageChanged(1);
            };

            var pagePre = function () {
                debugger;
                pageChanged($(token).data("pageIndex") - 1);
            };

            var pageLast = function () {
                pageChanged(Math.ceil($(token).data("totalCount") / $(token).data("pageSize")));
            };

            var pageNext = function () {
                debugger;
                pageChanged($(token).data("pageIndex") + 1);
            };

            var pageNumber = function () {
                pageChanged(parseInt($(this).text()));
            };

            var pageReflush = function () {
                pageChanged($(token).data("pageIndex"));
            }

            var pageGo = function () {
                var index = parseInt($(token + " .page_pos").val());
                var total = $(token).data("totalCount");
                if (index) {
                    if (index > total) {
                        pageLast();
                    }
                    else if (index < 1) {
                        pageFirst();
                    }
                    else {
                        pageChanged(index);
                    }
                }
                $(token + " .page_pos").val("");
            };
            var checkGoNumber = function () {
                if (!Number(this.value)) {
                    this.value = "";
                }
            };
            (function () {
                $(token).append("<div id='" + id + "_customer' class='page_num'></div><div class='page_btn page_first'></div><div class='page_btn page_prev'></div><div class='page_separator'></div><div id='" + id + "_num' class='page_num'></div><div class='page_separator'></div><div class='page_num'><input name='_pos' class='page_pos' type='text'/><span id='" + id + "_to'>Go</span></div><div class='page_separator'></div><div class='page_btn page_next'></div><div class='page_btn page_last'></div><div class='page_separator'></div><div class='page_btn page_reflush'></div><div style='clear:both;'></div>");
                $(token + " .page_reflush").bind("click", pageReflush);
                $(token + " .page_pos").bind("blur", checkGoNumber);
                $(token + "_to").bind("click", pageGo);
                $(token + " .page_reflush").hover(function () {
                    $(this).removeClass("page_btn").addClass("page_btn_actived");
                }, function () {
                    $(this).removeClass("page_btn_actived").addClass("page_btn");
                });
                if (!showNumberArea) {
                    $(token + "_num").next("div").remove();
                }
                if (!showPageInfo) {
                    $(token + "_customer").remove();
                }
                pageFirst();
            })();
        }
    }
})(jQuery);

